#include <fstream>
#include <stdlib.h>

using namespace std;

#include "gifti1file.h"
#include "gifti_io.h"

/*



*/


gifti1file::gifti1file() {

}

gifti1file::~gifti1file(){


}


void	gifti1file::initheader() {
}

bool	gifti1file::readheader(char *filename) {

	return false;
}

bool	gifti1file::writeheader() {

	return false;
}
/*! 
@function getcurrentheader
@abstract get headers of SRF that is currently opened in BrainVoyager QX
@discussion uses BVQX plugin access functions, e.g. qxGetMainHeaderOfCurrentSRF()
*/
bool	gifti1file::getcurrentheader(){

	bool success = false;

	return success;
}
/*! 
@function getcurrentdata
@abstract get data of SRF that is currently opened in BrainVoyager QX
@discussion uses BVQX plugin access functions, e.g. qxGetCurrentSRF(), converts the obtained unsigned char data to float
and saves them in the neuroimagefile field 'fdata'
*/
bool	gifti1file::getcurrentdata(){
	return false;
}

char *gifti1file::header2ascii(){ 

	char *instruction		= "Please select the GIfTI surface file";
	char *defaultFolder		= new char[256];
	qxGetBrainVoyagerQXPath(defaultFolder);
	char *typeOfFiles		= "GIfTI surface file file (*.gii)";
	char *filename			= new char[256];

	int usrResp = qxGetOpenFileName(instruction, "", typeOfFiles, filename);
	if (usrResp > 0) {
		return header2ascii(filename);
	}
	return "No success in reading the file";
}

char	*gifti1file::header2ascii(char *filename){
	
	char *buf; char *ebuf; int bufLen; 
	buf = (char *)calloc(1,65534); bufLen = 0;  

	try {

		sprintf(buf, "\nGIfTI filename: \n%s\n", filename); 
//		giiDataArray **arr = this->gifti1mainheader->meta[0]->name);// darray;
//		giiDataArray **arr = this->gifti1mainheader->meta[0]->value);
//		sprintf(buf, "\nGIfTI intent: \n%s\n", gifti_intent_to_string(&arr->datatype));
//		sprintf(buf, "\nGIfTI data type: \n%d\n", *arr.datatype);
	//	sprintf(buf+strlen(buf), "Number of dimensions: %d", this->gifti1mainheader.darray.num_dim);
	//	sprintf(buf+strlen(buf), "Data space: %s", this->gifti1mainheader->darray.coordsys->dataspace);
	//	sprintf(buf+strlen(buf), "XForm space: %s", this->gifti1mainheader.darray[0].coordsys.xformspace);
		bufLen = strlen(buf);
		buf  = (char *)realloc((void *)buf, bufLen+1);

	} catch (...) {
		qxLogText("Error while printing SRF header data to ascii");
		//	free(srf);
	}				

	return buf;
}


bool gifti1file::loaddata() {

	//	Triangle_Vertices *tri = new Triangle_Vertices[srfmainheader->NrOfTriangles];
	//	srfqx->Triangles = tri;
	return false;
}

bool gifti1file::copyheader(short int fromheadertoheader) {


	return false;
}

bool gifti1file::write() {

	return false;
}

