
#include "Plugin_MTC_Header.h"

#ifndef MTC_HEADER_H
#define MTC_HEADER_H

typedef struct {

	int		fileVersion;
	int		nrOfVertices;
	int		nrOfVolumes;
	char	*vtcFileName; 	
	char	*prtFileName; 
	int		hemoDynDelay;
	float	TR;
	float	HRFdelta;
	float	HRFtau;
	int		segmentSize;
	int		segmentOffset;
	char	MTCDataType;
	float	*data;
	char	*origName;

	// BrainVoyager specific header
	bool flag_bvqxhdr; 
	MTC_Header *mtcbvqx;


} mtcStruct;


#endif // MTC_HEADER_H


