/*
 *  classify.h
 *  gifti
 *
 *  Created by Hester Breman and Joost Mulders on 22/06/2008.
 *  Copyright 2008 Brain Innovation B.V. All rights reserved.
 *
 */
#include "gifti_io.h"

char *getAnatomicalStructurePrimary(char *origsrfname); 
char *getAnatomicalStructureSecondary(char *origsrfname); 
char *getGeometricType(char *origsrfname);
char *getTopologicalType(char *origsrfname);
int getGIfTIIntent(int bvqxmaptype);
int getBVQXmaptype(int niftimaptype); 
char *getBVMapName(gifti_image *gii, int mapnr);
bool iscurvature(char *bvqxmapname); 
bool getdistributionparams(gifti_image *gii, int mapnr, int bvqxmaptype, float *distrparams); 
int getnrofdistributionparams(int bvqxmaptype);