


#ifndef INFO_H
#define INFO_H

#include "gifti_io.h"
#include "SRF_Header.h"
#include "MTC_Header.h"
#include "SMP_Header.h"
#include "POI_Header.h"

//void error_message(int errortype, int filetype = 0);

bool getsrfinfo(bool exportfromdisk, bool write2disk, bool write2log);
bool getmtcinfo(bool exportfromdisk, bool write2disk, bool write2log);
bool getsmpinfo(bool exportfromdisk, bool write2disk, bool write2log);
bool getpoiinfo(bool exportfromdisk, bool write2disk, bool write2log);
bool getgiftiinfo(bool write2disk, bool write2log); 

void headerdump_gifti(gifti_image *giftiimg, bool write2disk, bool write2log, char *filename);
void headerdump_srf(srfStruct *srf, bool write2disk, bool write2log);
void headerdump_mtc(mtcStruct *mtc, bool write2disk, bool write2log); 
void headerdump_smp(smpStruct *smp, bool write2disk, bool write2log); 
void headerdump_poi(poiStruct *poi, bool write2disk, bool write2log); 

#endif // INFO_H